# Routines for Hashes. Version 1.0

sub read_h1 {
    my($file) = @_;
    my($key, $val, @e, %H1);

    if (-r "$file") {
	open (IN, "<$file") || die "Could not open \"$file\": $!\n";
	while (<IN>){
	    chop($_);
	    ($key, $val) = split(/$;/, $_);
	    $H1{$key} = $val;
	}
	close(IN);
	%H1;
    }
}


sub save_h1 {
    my($backup, $file, %H1) = @_;
    my($key1, $key2, $key3);
    
    if ($backup && -r "$file") {
        rename("$file", "$file.bak")
	    || die "Could not backup \"$file\" to \"$file.bak\": $!\n";
    }

    open (OUT, ">$file") || die "Could not open \"$file\": $!\n";
    
    foreach $key ( sort keys (%H1) ) {
	print OUT "$key$;$H1{$key}\n";
    }
    close(OUT);
}


sub print_h1 {
    my(%H1) = @_;
    my($key);
    
    foreach $key ( sort bynumber keys (%H1) ) {
        printf("%-15s $s\n", $key1, $H1{$key});
    }
}


sub bynumber { $a <=> $b; }

1;
