# Routines for Hashes of Hashes of Hashes. Version 1.0

sub read_h3 {
    my($file) = @_;
    my($key1, $key2, @e, %H3);

    if (-r "$file") {
	open (IN, "<$file") || die "Could not open \"$file\": $!\n";
	while (<IN>){
	    chop($_);
	    $key1 = $_;
	    $_ = <IN>;
	    do {
		chop($_);
		(@e) = split(/$;/, $_);
		$key2 = shift(@e);
		$H3{$key1}{$key2} = { @e };
		$_ = <IN>;
	    } until ($_ eq "\n" || $_ eq "");
	}
	close(IN);
	%H3;
    }
}


sub save_h3 {
    my($backup, $file, %H3) = @_;
    my($key1, $key2, $key3);
    
    if ($backup && -r "$file") {
        rename("$file", "$file.bak")
	    || die "Could not backup \"$file\" to \"$file.bak\": $!\n";
    }

    open (OUT, ">$file") || die "Could not open \"$file\": $!\n";
    
    foreach $key1 ( sort keys (%H3) ) {
	print OUT "$key1\n";
        foreach $key2 (keys %{ $H3{$key1} }) {
	    print OUT "$key2";
	    foreach $key3 (keys %{ $H3{$key1}{$key2} }) {
		print OUT "$;$key3$;$H3{$key1}{$key2}{$key3}";
	    }
	    print OUT "\n";
        }
        printf OUT "\n";
    }
    close(OUT);
}


sub print_h3 {
    my(%H3) = @_;
    my($key1, $key2, $key3);
    
    foreach $key1 ( sort keys (%H3) ) {
        print "$key1        ------------------------------------------------";
	print "----------------\n";
        foreach $key2 ( sort keys %{ $H3{$key1} } ) {
            print "\t$key2\n";
	    foreach $key3 ( sort keys %{ $H3{$key1}{$key2} } ) {
		print "\t\t$key3 = \"$H3{$key1}{$key2}{$key3}\"\n";
	    }
	}
    }
}


sub bynumber { $a <=> $b; }

1;
